Index: branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/HiveClient.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 10085)
+++ branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 10538)
@@ -351,5 +351,5 @@
     /// </summary>
     /// <param name="parentHiveTask">shall be null if its the root task</param>
-    private void UploadTaskWithChildren(Progress progress, HiveTask hiveTask, HiveTask parentHiveTask, IEnumerable<Guid> groups, int[] taskCount, int totalJobCount, Guid configPluginId, Guid jobId, ILog log, bool isPrivileged, CancellationToken cancellationToken) {
+    private void UploadTaskWithChildren(IProgress progress, HiveTask hiveTask, HiveTask parentHiveTask, IEnumerable<Guid> groups, int[] taskCount, int totalJobCount, Guid configPluginId, Guid jobId, ILog log, bool isPrivileged, CancellationToken cancellationToken) {
       taskUploadSemaphore.WaitOne();
       bool semaphoreReleased = false;
@@ -362,5 +362,5 @@
         List<IPluginDescription> plugins;
 
-        if (hiveTask.ItemTask.ComputeInParallel && (hiveTask.ItemTask.Item is Optimization.Experiment || hiveTask.ItemTask.Item is Optimization.BatchRun)) {
+        if (hiveTask.ItemTask.ComputeInParallel) {
           hiveTask.Task.IsParentTask = true;
           hiveTask.Task.FinishWhenChildJobsFinished = true;
Index: branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/HiveServiceLocator.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/HiveServiceLocator.cs	(revision 10085)
+++ branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/HiveServiceLocator.cs	(revision 10538)
@@ -21,4 +21,5 @@
 
 using System;
+using System.ServiceModel;
 using HeuristicLab.Clients.Common;
 
@@ -69,5 +70,5 @@
           return cl;
         }
-        catch (Exception exc) {
+        catch (EndpointNotFoundException exc) {
           exception = exc;
           EndpointRetries++;
Index: branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/HiveTasks/EngineHiveTask.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/HiveTasks/EngineHiveTask.cs	(revision 10085)
+++ branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/HiveTasks/EngineHiveTask.cs	(revision 10538)
@@ -32,6 +32,6 @@
     #region Constructors and cloning
     public EngineHiveTask() { }
-    public EngineHiveTask(EngineTask engineJob, IScope parentScopeClone)
-      : base(engineJob) {
+    public EngineHiveTask(EngineTask engineTask, IScope parentScopeClone)
+      : base(engineTask) {
       this.parentScopeClone = parentScopeClone;
     }
Index: branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs	(revision 10085)
+++ branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs	(revision 10538)
@@ -182,14 +182,14 @@
     }
 
-    public HiveTask(ItemTask itemJob, bool autoCreateChildHiveJobs)
+    public HiveTask(ItemTask itemTask, bool autoCreateChildHiveTasks)
       : this() {
-      this.syncTasksWithOptimizers = autoCreateChildHiveJobs;
-      this.ItemTask = itemJob;
+      this.syncTasksWithOptimizers = autoCreateChildHiveTasks;
+      this.ItemTask = itemTask;
       this.syncTasksWithOptimizers = true;
     }
 
-    public HiveTask(Task job, TaskData taskData, bool autoCreateChildHiveTasks) {
+    public HiveTask(Task task, TaskData taskData, bool autoCreateChildHiveTasks) {
       this.syncTasksWithOptimizers = autoCreateChildHiveTasks;
-      this.Task = job;
+      this.Task = task;
       try {
         this.ItemTask = PersistenceUtil.Deserialize<ItemTask>(taskData.Data);
@@ -545,5 +545,5 @@
     public new T ItemTask {
       get { return (T)base.ItemTask; }
-      internal set { base.ItemTask = value; }
+      set { base.ItemTask = value; }
     }
 
@@ -552,5 +552,5 @@
     [StorableConstructor]
     protected HiveTask(bool deserializing) { }
-    public HiveTask(T itemJob) : base(itemJob, true) { }
+    public HiveTask(T itemTask) : base(itemTask, true) { }
     protected HiveTask(HiveTask<T> original, Cloner cloner)
       : base(original, cloner) {
Index: branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs	(revision 10085)
+++ branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/RefreshableJob.cs	(revision 10538)
@@ -157,6 +157,6 @@
     }
 
-    private Progress progress;
-    public Progress Progress {
+    private IProgress progress;
+    public IProgress Progress {
       get { return progress; }
       set {
Index: branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs	(revision 10085)
+++ branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/ServiceClients/Task.cs	(revision 10538)
@@ -27,5 +27,7 @@
   public partial class Task : LightweightTask {
 
-    public Task() { }
+    public Task() {
+      Priority = 1;
+    }
 
     protected Task(Task original, Cloner cloner)
Index: branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs	(revision 10085)
+++ branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs	(revision 10538)
@@ -24,5 +24,4 @@
 using System.Linq;
 using System.Threading;
-using HeuristicLab.Clients.Hive.Jobs;
 using HeuristicLab.Common;
 
@@ -79,8 +78,8 @@
 
     public TaskDownloader(IEnumerable<Guid> jobIds) {
-      this.taskIds = jobIds;
-      this.taskDownloader = new ConcurrentTaskDownloader<ItemTask>(Settings.Default.MaxParallelDownloads, Settings.Default.MaxParallelDownloads);
-      this.taskDownloader.ExceptionOccured += new EventHandler<EventArgs<Exception>>(taskDownloader_ExceptionOccured);
-      this.results = new Dictionary<Guid, HiveTask>();
+      taskIds = jobIds;
+      taskDownloader = new ConcurrentTaskDownloader<ItemTask>(Settings.Default.MaxParallelDownloads, Settings.Default.MaxParallelDownloads);
+      taskDownloader.ExceptionOccured += new EventHandler<EventArgs<Exception>>(taskDownloader_ExceptionOccured);
+      results = new Dictionary<Guid, HiveTask>();
     }
 
@@ -88,16 +87,11 @@
       foreach (Guid taskId in taskIds) {
         taskDownloader.DownloadTaskDataAndTask(taskId,
-          (localJob, itemJob) => {
-            if (localJob != null && itemJob != null) {
-              HiveTask hiveTask;
-              if (itemJob is OptimizerTask) {
-                hiveTask = new OptimizerHiveTask((OptimizerTask)itemJob);
-              } else {
-                hiveTask = new HiveTask(itemJob, true);
-              }
-              hiveTask.Task = localJob;
+          (localTask, itemTask) => {
+            if (localTask != null && itemTask != null) {
+              HiveTask hiveTask = itemTask.CreateHiveTask();
+              hiveTask.Task = localTask;
               try {
                 resultsLock.EnterWriteLock();
-                this.results.Add(localJob.Id, hiveTask);
+                results.Add(localTask.Id, hiveTask);
               }
               finally { resultsLock.ExitWriteLock(); }
@@ -113,6 +107,6 @@
     public event EventHandler<EventArgs<Exception>> ExceptionOccured;
     private void OnExceptionOccured(Exception exception) {
-      this.exceptionOccured = true;
-      this.currentException = exception;
+      exceptionOccured = true;
+      currentException = exception;
       var handler = ExceptionOccured;
       if (handler != null) handler(this, new EventArgs<Exception>(exception));
Index: branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs	(revision 10085)
+++ branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs	(revision 10538)
@@ -29,4 +29,9 @@
   [StorableClass]
   public class EngineTask : ItemTask {
+    public override HiveTask CreateHiveTask() {
+      //only used when deserializing, so no problem with parentscope
+      return new EngineHiveTask(this, null);
+    }
+
     [Storable]
     protected IOperation initialOperation;
@@ -54,4 +59,6 @@
       this.Item = engine;
     }
+
+    public EngineTask(IEngine engine) : base(engine) { }
 
     [StorableConstructor]
Index: branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/Tasks/ItemTask.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/Tasks/ItemTask.cs	(revision 10085)
+++ branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/Tasks/ItemTask.cs	(revision 10538)
@@ -22,8 +22,10 @@
 using System;
 using System.Drawing;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Hive;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Clients.Hive {
@@ -31,6 +33,11 @@
   [StorableClass]
   public abstract class ItemTask : NamedItem, ITask {
+    public virtual HiveTask CreateHiveTask() {
+      return new HiveTask(this, true);
+    }
+
     public virtual bool IsParallelizable {
       get { return true; }
+      set { }
     }
 
@@ -71,4 +78,7 @@
       this.Item = cloner.Clone(original.Item);
     }
+    public ItemTask(IItem item) {
+      Item = item;
+    }
 
     [StorableHook(HookType.AfterDeserialization)]
@@ -211,4 +221,27 @@
       return Name;
     }
+
+    #region Helpers
+    public static bool IsTypeSupported(Type itemType) {
+      var supportedHiveTaskTypes = ApplicationManager.Manager.GetTypes(typeof(ItemTask))
+          .Select(t => t.GetProperties().Single(x => x.Name == "Item" && x.PropertyType != typeof(IItem)).PropertyType);
+      return supportedHiveTaskTypes.Any(x => x.IsAssignableFrom(itemType));
+    }
+
+    public static Type GetHiveTaskType(Type itemType) {
+      if (!IsTypeSupported(itemType)) throw new Exception("Item " + itemType + " is not supported for Hive.");
+
+      var typeHiveTaskMap = ApplicationManager.Manager.GetTypes(typeof(ItemTask))
+          .Select(t => new Tuple<Type, Type>(t.GetProperties().Single(x => x.Name == "Item" && x.PropertyType != typeof(IItem)).PropertyType, t));
+
+      return typeHiveTaskMap.Single(x => x.Item1.IsAssignableFrom(itemType)).Item2;
+    }
+
+    public static ItemTask GetItemTaskForItem(IItem item) {
+      Type itemType = item.GetType();
+      Type hiveTaskType = GetHiveTaskType(itemType);
+      return Activator.CreateInstance(hiveTaskType, new object[] { item }) as ItemTask;
+    }
+    #endregion
   }
 }
Index: branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs	(revision 10085)
+++ branches/DataPreprocessing/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs	(revision 10538)
@@ -30,4 +30,8 @@
   [StorableClass]
   public class OptimizerTask : ItemTask {
+    public override HiveTask CreateHiveTask() {
+      return new OptimizerHiveTask(this);
+    }
+
     public override bool IsParallelizable {
       get { return this.Item is Experiment || this.Item is BatchRun; }
@@ -46,11 +50,9 @@
     }
 
-    public OptimizerTask(IOptimizer optimizer) {
-      this.Item = optimizer;
-
-      if (optimizer is Experiment) {
+    public OptimizerTask(IOptimizer optimizer)
+      : base(optimizer) {
+
+      if (optimizer is Experiment || optimizer is BatchRun) {
         this.ComputeInParallel = true;
-      } else if (optimizer is BatchRun) {
-        this.ComputeInParallel = false;
       } else {
         this.ComputeInParallel = false;
